// Generated by CoffeeScript 1.12.1

/*
Checkbox for selecting/deselecting all rows in a table
  - when multiselect is clicked, it will add 'isSelected' to all rows

@param [Array] rows - rows that are selectable
@example
table.table(st-table='displayRows' st-safe-src='rows')
  thead
    tr
      th
        multiselect-checkbox(models='displayRows')
  tbody
    tr(ng-repeat='row in displayRows')
      td
        input(ng-model='row.isSelected')
 */
require('angular-indeterminate-checkbox');

angular.module('multiselectCheckbox', ['ngIndeterminateCheckbox']).directive('multiselectCheckbox', function() {
  return {
    restrict: 'E',
    template: require('./template'),
    scope: {
      models: '='
    },
    link: function(scope, element, attrs) {
      var getSelectedRows, isSelectable;
      scope.checked = false;
      getSelectedRows = function() {
        var ref;
        return (ref = scope.models) != null ? ref.filter(function(row) {
          return row != null ? row.isSelected : void 0;
        }).length : void 0;
      };
      isSelectable = function(row) {
        if (row.isSelectable == null) {
          return true;
        }
        return row.isSelectable;
      };
      scope.$watch('checked', function(newValue, oldValue) {
        var i, len, ref, results, row;
        if (newValue === oldValue) {
          return;
        }
        ref = scope.models;
        results = [];
        for (i = 0, len = ref.length; i < len; i++) {
          row = ref[i];
          if (isSelectable(row)) {
            results.push(row.isSelected = newValue);
          }
        }
        return results;
      });
      return scope.$watch(getSelectedRows, function(count) {
        var ref;
        if (count === void 0) {
          return;
        }
        if (count === 0) {
          scope.checked = false;
          return scope.indeterminate = false;
        } else if (count === ((ref = scope.models) != null ? ref.filter(isSelectable).length : void 0)) {
          scope.checked = true;
          return scope.indeterminate = false;
        } else {
          return scope.indeterminate = true;
        }
      });
    }
  };
});

if (typeof module !== "undefined" && module !== null) {
  module.exports = 'multiselectCheckbox';
}
